/**
 *
 * @author Sebastian Widelak (c) 2013
 */
(function (window, undefined) {
    /**
     *
     * @type {function}
     */
    window.AnswerView = View.extend(function AnswerView(opts) {
        View.prototype.constructor.call(this, opts);
    });

    AnswerView.prototype.isValid = function () {
        var models = this.get('config').models || {};
        return models.correct;
    };

    AnswerView.prototype.isSelected = function () {
        return this.get('selected') || false;
    };

    AnswerView.prototype.markInvalid = function () {
        if (this.get('el').className.indexOf("answer-invalid") < 0) {
            this.get('el').className += " answer-invalid";
        }
    };

    AnswerView.prototype.markValid = function () {
        if (this.get('el').className.indexOf("answer-valid") < 0) {
            this.get('el').className += " answer-valid";
            this.set('selected', true);
        }
    };

    AnswerView.prototype.clear = function () {
        this.get('el').className = this.get('el').className.replace(" answer-invalid", "");
        this.get('el').className = this.get('el').className.replace(" answer-valid", "");
        this.set('selected', false);
    };

}(window));