/**
 *
 * @author Sebastian Widelak (c) 2013
 */
(function (window, undefined) {
    /**
     *
     * @type {function}
     */
    window.OverlayView = View.extend(function OverlayQuestionView(opts) {
        View.prototype.constructor.call(this, opts);
    });

    OverlayView.prototype.show = function (callback) {
        var me = this,
            dom = me.get('el'),
            config = me.get('config');

        if (me.get('isAnimated')) {
            jQuery(dom).stop();
        }
        me.set('isAnimated', true);
        jQuery(dom).css({
            display: 'block',
            opacity: 0
        }).animate({
                opacity: 1
            }, config.showDuration || 500, function () {
                me.set('isAnimated', false);
                if (callback)
                    callback(me, this);
            });
    };

    OverlayView.prototype.hide = function (callback) {
        var me = this,
            dom = me.get('el'),
            config = me.get('config');
        if (me.get('isAnimated')) {
            jQuery(dom).stop();
        }
        me.set('isAnimated', true);
        jQuery(dom).animate({
            opacity: 0
        }, config.hideDuration || 500, function () {
            jQuery(dom).css({
                display: 'none'
            });
            me.set('isAnimated', false);
            if (callback)
                callback(me, this);
        });
    }
}(window));