/**
 *
 * @author Sebastian Widelak (c) 2013
 */
(function (window, undefined) {
    /**
     *
     * @type {function}
     */
    window.QuestionView = View.extend(function QuestionView(opts) {
        View.prototype.constructor.call(this, opts);
    });

    /**
     *
     * @param item
     * @returns {*}
     */
    QuestionView.prototype.generateElement = function (item) {
        var element;
        switch (item.type) {
            case 'title' :
            {
                element = new View({
                    config: {
                        tpl: 'question-title',
                        models: item
                    }
                });
                break;
            }
            case 'image' :
            {
                element = new View({
                    config: {
                        tpl: 'question-image',
                        models: item
                    }
                });
                break;
            }
            case 'content' :
            {
                element = new View({
                    config: {
                        tpl: 'question-content',
                        models: item
                    }
                });
                break;
            }
            case 'answers' :
            {
                element = new AnswersView({
                    config: {
                        tpl: 'question-answers',
                        models: item
                    }
                });
                element.generateContent();
                break;
            }
        }
        element.render();
        return element;
    };

    QuestionView.prototype.generateContent = function () {
        var me = this,
            models = me.get('config').models.items || {},
            element;
        for (var i = 0, len = models.length; i < len; i++) {
            element = me.generateElement(models[i]);
            element.appendTo(me, '.question-cell');
        }
    };
}(window));